/*  Bill Rouady
    Netscape Communications, Inc.
    April, 1996
	Updated to new API: May/June 1996
*/

import java.applet.Applet;
import java.applet.AudioClip;
import java.awt.*;
import l3d.*;
import netscape.javascript.JSObject;

/**

    mousecare applet:  Class Definition
        Applet which runs Care and Feeding of Mouse demo

*/

public class mousecare extends Applet implements Runnable {

    // variables

	JSObject document;
	L3DScene l3d;

    L3DObject nMainMouse;
    L3DObject nText1;
    L3DObject nText2;
    L3DObject nButtonText;
    L3DObject nLeftText;
    L3DObject nRightText;
    L3DObject nTopCover;
    L3DObject nHoleCover;
    L3DObject nHoleCover2;
    L3DObject nMouseBall;
    L3DObject nSwab;
    
    int nFrameCount = 15;
    int showScene = 0;

    boolean buttonHold = true;  // Disable buttons for rotation
    boolean backPush = false;  // defines a backbutton push

    Button backButton = new Button("Back");
    Button forwardButton = new Button("Forward");
    Panel bottomPanel = new Panel();
    Label topText = new Label("Mouse Care 101", Label.CENTER);
    Label mid1Text = new Label("All the info you need", Label.CENTER);
    Label mid2Text = new Label("to care for your special mouse.", Label.CENTER);
    Thread mouseThread;

/*
    mousecare applet:  init method
*/

    public void init() {

	// Main Initialization
   		document = getDocument();
		l3d = (L3DScene)document.getMember("l3d");


	// Object Initialization

		while(nMainMouse==null) {
			nMainMouse = l3d.getObject("FullMouse");
		}

		nText1 = l3d.getObject("CareText");

		nText2 = l3d.getObject("MouseText");

    // Applet Display

        bottomPanel.setLayout(new GridLayout(1,2));
        bottomPanel.setFont(new Font("TimesRoman", Font.BOLD, 14));
        bottomPanel.add(backButton);
        bottomPanel.add(forwardButton);

        setLayout(new GridLayout(4,1));
        topText.setFont(new Font("Helvetica", Font.BOLD, 16));
        mid1Text.setFont(new Font("Helvetica", Font.BOLD, 14));
        mid2Text.setFont(new Font("Helvetica", Font.BOLD, 14));
        add(topText);
        add(mid1Text);
        add(mid2Text);
        add(bottomPanel);

        backButton.disable();
        forwardButton.disable();

    }


/*
    mousecare applet:  start method
*/

    public void start() {

    	mouseThread = new Thread(this);
    	mouseThread.start();

    }

/*
    mousecare applet:  run method										 
*/

    public void run() {

   	    try {Thread.currentThread().sleep(4000);} catch (InterruptedException e){}

        float ff = 0.0f;

    // Spin Mouse Intro
        for(int i=0; i<62; i++) {
            ff = ff + .1f;
            nMainMouse.rotate(0.0f, 0.1f, 0.0f, 1, 1);
            l3d.render();
        }

    // Rotation bug Correction
        nMainMouse.rotate(0.0f, 0.08f, 0.0f, 1, 1);
        l3d.render();


    // Fade Top Text Out
        for(ff=0.0f;ff<=1.0f;ff+=(float).1f) {

            nText1.setTransparency(ff) ;
            l3d.render() ;

        }

    // bug in JAVA to make disappear
        nText1.hide();
        l3d.render();

    // Fade Bottom Text Out
        for(ff=0.0f;ff<=1.0f;ff+=(float).1f) {

            nText2.setTransparency(ff) ;
            l3d.render() ;

        }

    // JAVA bug fix -- part 2
        nText2.hide();
        l3d.render();

    // Camera Zoom in
        float fXPos = 0.0f;
        float fYPos = 120.0f;
        float fZPos = 500.0f;
        float fXLookAt = 0.0f;
        float fYLookAt = 0.0f;
        float fZLookAt = -1.0f;
        float fXLookUp = 0.0f;
        float fYLookUp = 1.0f;
        float fZLookUp = 0.0f;
        for(fZPos=500.0f; fZPos>300.0f; fZPos=fZPos-10.0f) {
            l3d.setCameraView(fXPos, fYPos, fZPos,
                              fXLookAt, fYLookAt, fZLookAt,
                              fXLookUp, fYLookUp, fZLookUp);
            l3d.render();
        }

    // RE-ENABLE buttons
        mid1Text.setText("Press the FORWARD Button");
        mid2Text.setText("to begin...");
        forwardButton.enable();
        buttonHold = false;

    }

/*
    mousecare applet:  stop method
*/

    public void stop() {

        mouseThread.stop();

    }

    public void paint() {

    }

    public boolean action(Event evt, Object arg) {

        if(buttonHold) {
            return false;
        }
        if(evt.target instanceof Button) {

            if((String)arg == "Back") {

                backPush = true;
                if(showScene == 0) {
                    showScene = 11;
                }
                else {
                    showScene = showScene - 2;
                }
            }


            switch(showScene) {

            // Fly Around the Mouse
                case 0: {

                    if(backPush) {
                    // Hide Button Text
                        nButtonText.setTransparency(1.0f) ;
                    // Hide Left Text
                        nLeftText.setTransparency(1.0f) ;
                    // Reset Left Text
                        nLeftText.translate(-388.0f, 190.0f, 0.0f, 2, 0);
                    // Render Changes
                        l3d.render() ;
                        backPush = false;
                    }

                    buttonHold = true;
                    backButton.disable();
                    forwardButton.disable();
                    topText.setText("Examining the Mouse");
                    mid1Text.setText("Check out the wonderful ergonomics");
                    mid2Text.setText("of the modern-day mouse!!!");
                    float fXPos = 0.0f;
                    float fYPos = 120.0f;
                    float fZPos = 350.0f;
                    float fXLookAt = 0.0f;
                    float fYLookAt = 0.0f;
                    float fZLookAt = -1.0f;
                    float fXLookUp = 0.0f;
                    float fYLookUp = 1.0f;
                    float fZLookUp = 0.0f;
                    for(int i=1; i<11; i++) {
                        fXPos = fXPos + 35f;
                        fZPos = fZPos - 35f;
                        fXLookAt = fXLookAt - .1f;
                        fZLookAt = fZLookAt + .1f;
                        l3d.setCameraView(fXPos, fYPos, fZPos,
                                          fXLookAt, fYLookAt, fZLookAt,
                                          fXLookUp, fYLookUp, fZLookUp);
                        l3d.render();
                    }
                    for(int i=1; i<6; i++) {
                        fYLookUp = fYLookUp - .2f;
                        fZLookUp = fZLookUp + .2f;
                        l3d.setCameraView(fXPos, fYPos, fZPos,
                                          fXLookAt, fYLookAt, fZLookAt,
                                          fXLookUp, fYLookUp, fZLookUp);
                        l3d.render();
                    }
             	   try {Thread.currentThread().sleep(1500);} catch (InterruptedException e){}
                   mid1Text.setText("The organic contours");
                   mid2Text.setText("designed to comfortably fit the hand.");
                   for(int i=1; i<6; i++) {
                        fYLookUp = fYLookUp + .2f;
                        fZLookUp = fZLookUp - .2f;
                        l3d.setCameraView(fXPos, fYPos, fZPos,
                                          fXLookAt, fYLookAt, fZLookAt,
                                          fXLookUp, fYLookUp, fZLookUp);
                        l3d.render();
                    }
                    for(int i=1; i<11; i++) {
                        fXPos = fXPos - 35f;
                        fZPos = fZPos - 35f;
                        fXLookAt = fXLookAt + .1f;
                        fZLookAt = fZLookAt + .1f;
                        l3d.setCameraView(fXPos, fYPos, fZPos,
                                          fXLookAt, fYLookAt, fZLookAt,
                                          fXLookUp, fYLookUp, fZLookUp);
                        l3d.render();
                    }
                    for(int i=1; i<11; i++) {
                        fXPos = fXPos - 35f;
                        fZPos = fZPos + 35f;
                        fXLookAt = fXLookAt + .1f;
                        fZLookAt = fZLookAt - .1f;
                        l3d.setCameraView(fXPos, fYPos, fZPos,
                                          fXLookAt, fYLookAt, fZLookAt,
                                          fXLookUp, fYLookUp, fZLookUp);
                        l3d.render();
                    }
                    for(int i=1; i<11; i++) {
                        fXPos = fXPos + 35f;
                        fZPos = fZPos + 35f;
                        fXLookAt = fXLookAt - .1f;
                        fZLookAt = fZLookAt - .1f;
                        l3d.setCameraView(fXPos, fYPos, fZPos,
                                          fXLookAt, fYLookAt, fZLookAt,
                                          fXLookUp, fYLookUp, fZLookUp);
                        l3d.render();
                    }
                    buttonHold = false;
                    forwardButton.enable();
                    showScene++;
                    break;
                }

            // Introduce Left Mouse Button
                case 1:  {

                    if(backPush) {

                    // Hide and Move Button Text Back
                        nButtonText.setTransparency(1.0f) ;
                        nButtonText.translate(0.0f, 0.0f, 0.0f, 2, 0);
                    // Hide Right Text
                        nRightText.setTransparency(1.0f) ;
                    // Reset Left Text
                        nLeftText.translate(-388.0f, 190.0f, 0.0f, 2, 0);
                    // Reset Right Text
                        nRightText.translate(40f, 390f, 0.0f, 2, 0);
                    // Render Changes
                        l3d.render() ;
                        backPush = false;
                    }


                    buttonHold = true;
                    backButton.disable();
                    forwardButton.disable();

                    mid1Text.setText("This is the LEFT mouse button.");
                    mid2Text.setText("It is also known as Button 1.");

                // Get ButtonText ID
                    nButtonText = l3d.getObject("ButtonText");

                // Fade Button Text In
                    for(float ff=1.0f;ff>=0.0f;ff-=.1f) {

                        nButtonText.setTransparency(ff) ;
                        l3d.render() ;
                    }
                    nButtonText.setTransparency(0.0f) ;

                // Get LeftText ID
					nLeftText = l3d.getObject("LeftText");

                // LeftText appears and flies in
                    nLeftText.setTransparency(0.0f) ;
                    float fXPos = -388.0f;
                    for(int i=0; i<10; i++) {
                        fXPos = fXPos + 20.0f;
                        nLeftText.translate(fXPos, 190.0f, 0.0f, 2, 0);
                        l3d.render() ;
                    }

              	    try {Thread.currentThread().sleep(1000);} catch (InterruptedException e){}

                    buttonHold = false;
                    backButton.enable();
                    forwardButton.enable();
                    showScene++;
                    break;
                }

            // Introduce Right Mouse Button
                case 2:  {

                    if(backPush) {
                    // Move Button Text Back
                        nButtonText.translate(0.0f, 0.0f, 0.0f, 2, 0);
                    // Hide Right Text
                        nRightText.setTransparency(1.0f) ;
                    // Show Left Text Again
                        nLeftText.setTransparency(0.0f) ;
                    // Show Button Text Again
                        nButtonText.setTransparency(0.0f) ;
                    // Reset Right Text
                        nRightText.translate(40f, 390f, 0.0f, 2, 0);
                    // Render Changes
                        l3d.render() ;
                        backPush = false;
                    }


                    buttonHold = true;
                    backButton.disable();
                    forwardButton.disable();

                    mid1Text.setText("This is the RIGHT Button.");
                    mid2Text.setText("It is often referred to as Button 2.");

                // Fade Left Text Out
                    for(float ff=0.0f;ff<=1.0f;ff+=.2f) {

                        nLeftText.setTransparency(ff) ;
                        l3d.render() ;
                    }
                    nLeftText.setTransparency(1.0f) ;

                // Move Button Text Over
                    float fXPos = 0.0f;
                    for(int i=0; i<10; i++) {
                        fXPos = fXPos + 24.0f;
                        nButtonText.translate(fXPos, 0.0f, 0.0f, 2, 0);
                        l3d.render() ;
                    }

                // Get RightText ID
                    nRightText = l3d.getObject("RightText");

                // RightText appears and flies in
                    nRightText.setTransparency(0.0f) ;
                    float fYPos = 390.0f;
                    for(int i=0; i<10; i++) {
                        fYPos = fYPos - 20.0f;
                        nRightText.translate(40, fYPos, 0.0f, 2, 0);
                        l3d.render() ;
                    }

              	    try {Thread.currentThread().sleep(1000);} catch (InterruptedException e){}

                    buttonHold = false;
                    backButton.enable();
                    forwardButton.enable();
                    showScene++;
                    break;
                }

            // Quick Peek at Mouse Guts
                case 3:  {

                    if(backPush) {
                    // Show Button Text
                        nButtonText.setTransparency(0.0f) ;
                    // Show Right Text
                        nRightText.setTransparency(0.0f) ;
                    // Reset Right Text
                        nRightText.translate(40f, 190f, 0.0f, 2, 0);
                    // Reset Camera
                        l3d.setCameraView(0f, 120f, 350f,
                                          0f, 0f, -1f,
                                          0f, 1f, 0f);
                   // Render Changes
                        l3d.render() ;

                        backPush = false;
                    }


                    buttonHold = true;
                    backButton.disable();
                    forwardButton.disable();

                // Fade Button Text Out
                    for(float ff=0.0f;ff<=1.0f;ff+=.2f) {

                        nButtonText.setTransparency(ff) ;
                        l3d.render() ;
                    }
                    nButtonText.setTransparency(1.0f) ;

                // RightText flies out and disappears
                    float fXPos = 40.0f;
                    float fYPos = 190.0f;
                    float fZPos = 0.0f;
                    for(int i=0; i<10; i++) {
                        fXPos = fXPos - 4.0f;
                        fYPos = fYPos - 7.0f;
                        fZPos = fZPos + 35.0f;
                        nRightText.translate(fXPos, fYPos, fZPos, 2, 0);
                        l3d.render() ;
                    }
                    nRightText.setTransparency(1.0f) ;
                    l3d.render() ;

                    mid1Text.setText("Let's take a quick peek");
                    mid2Text.setText("at the heart of the mouse.");

                // Get TopCover ID
                    nTopCover = l3d.getObject("MouseTop");

                // Fade Top Cover 80 percent
                    for(float ff=0.0f;ff<=0.8f;ff+=.1f) {
                        nTopCover.setTransparency(ff) ;
                        l3d.render() ;
                    }
              	    try {Thread.currentThread().sleep(2000);} catch (InterruptedException e){}
                // Reappear Top Cover
                    for(float ff=0.8f;ff>=0.0f;ff-=.1f) {
                        nTopCover.setTransparency(ff) ;
                        l3d.render() ;
                    }
                    nTopCover.setTransparency(0.0f) ;
                    l3d.render() ;

                    buttonHold = false;
                    backButton.enable();
                    forwardButton.enable();
                    showScene++;
                    break;
                }

            // Move Around to Mouse Backside and check out its ball
                case 4: {

                    if(backPush) {
                    // Reset Text
                        topText.setText("Examining the Mouse");
                    // Old Texture back on HoleCover
                        nHoleCover.setTransparency(0.0f) ;
                        nHoleCover2.setTransparency(1.0f) ;

                    // Return HoleCover to start position
                        nHoleCover2.translate(0.0f, 0.0f, 0.0f, 2, 0);
                    // Reset Camera
                        l3d.setCameraView(0f, 120f, 350f,
                                          0f, 0f, -1f,
                                          0f, 1f, 0f);
                   // Render Changes
                        l3d.render() ;
                        backPush = false;
                    }


                    buttonHold = true;
                    backButton.disable();
                    forwardButton.disable();

                // Move Camera to Rear View
                    float fXPos = 0.0f;
                    float fYPos = 120.0f;
                    float fZPos = 350.0f;
                    float fXLookAt = 0.0f;
                    float fYLookAt = 0.0f;
                    float fZLookAt = -1.0f;
                    float fXLookUp = 0.0f;
                    float fYLookUp = 1.0f;
                    float fZLookUp = 0.0f;
                    for(int i=1; i<11; i++) {
                        fXPos = fXPos + 35f;
                        fZPos = fZPos - 35f;
                        fXLookAt = fXLookAt - .1f;
                        fZLookAt = fZLookAt + .1f;
                        l3d.setCameraView(fXPos, fYPos, fZPos,
                                          fXLookAt, fYLookAt, fZLookAt,
                                          fXLookUp, fYLookUp, fZLookUp);
                        l3d.render();
                    }
                    for(int i=1; i<11; i++) {
                        fXPos = fXPos - 37f;
                        fZPos = fZPos - 25f;
                        fXLookAt = fXLookAt + .1f;
                        fZLookAt = fZLookAt + .1f;
                        l3d.setCameraView(fXPos, fYPos, fZPos,
                                          fXLookAt, fYLookAt, fZLookAt,
                                          fXLookUp, fYLookUp, fZLookUp);
                        l3d.render();
                    }

                    mid1Text.setText("This is the mouse ball.");
                    mid2Text.setText("Our cleaning operation begins here...");

                    buttonHold = false;
                    backButton.enable();
                    forwardButton.enable();
                    showScene++;
                    break;
                }

            // Disassemble Hole Cover
                case 5: {

                    if(backPush) {

                    // Old Texture back on Cover
                        nHoleCover.setTransparency(0.0f) ;
                        nHoleCover2.setTransparency(1.0f) ;
                    // Return HoleCover to start position
                        nHoleCover2.translate(0.0f, 0.0f, 0.0f, 2, 0);
                    // Return MouseBall to start position
                        nMouseBall.translate(0.0f, 0.0f, 0.0f, 2, 0);
                   // Render Changes
                        l3d.render() ;
                        backPush = false;
                    }


                    buttonHold = true;
                    backButton.disable();
                    forwardButton.disable();

                    topText.setText("Cleaning the Mouse");
                    mid1Text.setText("First, twist to loosen the cover");
                    mid2Text.setText("over the mouse ball.");

                // Get HoleCover ID
                    nHoleCover = l3d.getObject("HoleCover");

                // Get HoleCover2 ID
					nHoleCover2 = l3d.getObject("HoleCover2");

                // Dissolve from HoleCover to HoleCover2 (fake rotation hack)
                    for(float ff=0.0f;ff<=1.0f;ff+=.1f) {
                        nHoleCover.setTransparency(ff) ;
                        nHoleCover2.setTransparency(1.0f-ff) ;
                        l3d.render() ;
                    }
                    nHoleCover.setTransparency(1.0f) ;
                    nHoleCover2.setTransparency(0.0f) ;
                    l3d.render() ;

              	    try {Thread.currentThread().sleep(500);} catch (InterruptedException e){}

                    mid1Text.setText("Remove the cover.");
                    mid2Text.setText("");

                // Move Hole Cover2 Out
                    float fZPos = 0.0f;
                    for(int i=0; i<10; i++) {
                        fZPos = fZPos - 4.0f;
                        nHoleCover2.translate(0.0f, 0.0f, fZPos, 2, 0);
                        l3d.render() ;
                    }

              	    try {Thread.currentThread().sleep(500);} catch (InterruptedException e){}

                // Move Hole Cover2 Over
                    float fXPos = 0.0f;
                    for(int i=0; i<10; i++) {
                        fXPos = fXPos + 9.0f;
                        nHoleCover2.translate(fXPos, 0.0f, fZPos, 2, 0);
                        l3d.render() ;
                    }

                    buttonHold = false;
                    backButton.enable();
                    forwardButton.enable();
                    showScene++;
                    break;
                }

            // Remove Mouse Ball
                case 6: {

                    if(backPush) {

                    // Return MouseBall to start position
                        nMouseBall.translate(0.0f, 0.0f, 0.0f, 2, 0);
                    // Make Swab invisible (one for transparent from .wrl, one for hidden on reset)
                        nSwab.setTransparency(1.0f) ;
                        nSwab.hide();
                    // Move Swab Back
                        nSwab.translate(0.0f, 0.0f, 0.0f, 2, 0);
                   // Render Changes
                        l3d.render() ;
                        backPush = false;
                    }


                    buttonHold = true;
                    backButton.disable();
                    forwardButton.disable();

                    mid1Text.setText("Next, remove the Mouse ball");
                    mid2Text.setText("from its cavity.");

                // Get Mouseball ID
					nMouseBall = l3d.getObject("MouseBall");

                // Move MouseBall Out
                    float fZPos = 0.0f;
                    for(int i=0; i<10; i++) {
                        fZPos = fZPos - 6.0f;
                        nMouseBall.translate(0.0f, 0.0f, fZPos, 2, 0);
                        l3d.render() ;
                    }

              	    try {Thread.currentThread().sleep(500);} catch (InterruptedException e){}

                // Move MouseBall Over
                    float fXPos = 0.0f;
                    for(int i=0; i<10; i++) {
                        fXPos = fXPos - 8.0f;
                        nMouseBall.translate(fXPos, 0.0f, fZPos, 2, 0);
                        l3d.render() ;
                    }

                    buttonHold = false;
                    backButton.enable();
                    forwardButton.enable();
                    showScene++;
                    break;
                }

            // Cleaning top roller with swab
                case 7: {

                    if(backPush) {
                    // Make Swab invisible (one for transparent from .wrl, one for hidden on reset)
                        nSwab.hide();
                    // Move Swab Back
                        nSwab.translate(0.0f, 0.0f, 0.0f, 2, 0);
                   // Render Changes
                        l3d.render() ;
                        backPush = false;
                    }


                    buttonHold = true;
                    backButton.disable();
                    forwardButton.disable();

                    mid1Text.setText("Using an alcohol tipped swab,");
                    mid2Text.setText("thoroughly clean the top roller.");

                // Get Swab ID
                    nSwab = l3d.getObject("Swab");

                // Make Swab visible (one for transparent from .wrl, one for hidden on reset)
                    nSwab.setTransparency(0.0f) ;
                    nSwab.show();

                // Move Swab Inside
                    float fZPos = 0.0f;
                    for(int i=0; i<10; i++) {
                        fZPos = fZPos + 4.0f;
                        nSwab.translate(0.0f, 0.0f, fZPos, 2, 0);
                        l3d.render() ;
                    }

                // Move Swab Up
                    float fYPos = 0.0f;
                    for(int i=0; i<10; i++) {
                        fYPos = fYPos + 3.0f;
                        nSwab.translate(0.0f, fYPos, fZPos, 2, 0);
                        l3d.render() ;
                    }

                // Move Swab Back and Forth
                    float fXPos = 0.0f;
                    for(int i=0; i<3; i++) {
                        nSwab.translate(fXPos-5.0f, fYPos, fZPos, 2, 0);
                        l3d.render() ;
                        nSwab.translate(fXPos, fYPos, fZPos, 2, 0);
                        l3d.render() ;
                        nSwab.translate(fXPos+5.0f, fYPos, fZPos, 2, 0);
                        l3d.render() ;
                        nSwab.translate(fXPos, fYPos, fZPos, 2, 0);
                        l3d.render() ;
                    }

                    buttonHold = false;
                    backButton.enable();
                    forwardButton.enable();
                    showScene++;
                    break;

                }

            // Clean side (2nd) Roller
                case 8: {

                    if(backPush) {
                    // Move Swab Back
                        nSwab.translate(0.0f, 30.0f, 40.0f, 2, 0);
                   // Render Changes
                        l3d.render() ;
                        backPush = false;
                    }


                    buttonHold = true;
                    backButton.disable();
                    forwardButton.disable();

                    mid1Text.setText("Then clean the side roller.");
                    mid2Text.setText("");

                // Move Swab Over
                    float fXPos = 0.0f;
                    float fYPos = 30.0f;
                    float fZPos = 40.0f;
                    for(int i=0; i<10; i++) {
                        fXPos = fXPos + 2.5f;
                        fYPos = fYPos - 3.0f;
                        nSwab.translate(fXPos, fYPos, fZPos, 2, 0);
                        l3d.render() ;
                    }

                // Move Swab Back and Forth
                    for(int i=0; i<3; i++) {
                        nSwab.translate(fXPos, fYPos + 5.0f, fZPos, 2, 0);
                        l3d.render() ;
                        nSwab.translate(fXPos, fYPos, fZPos, 2, 0);
                        l3d.render() ;
                        nSwab.translate(fXPos, fYPos - 5.0f, fZPos, 2, 0);
                        l3d.render() ;
                        nSwab.translate(fXPos, fYPos, fZPos, 2, 0);
                        l3d.render() ;
                    }

                    buttonHold = false;
                    backButton.enable();
                    forwardButton.enable();
                    showScene++;
                    break;


                }

            // Cleaning bottom (3rd) Roller
                case 9: {

                    if(backPush) {
                    // Make Swab visible (one for transparent from .wrl, one for hidden on reset)
                        nSwab.setTransparency(0.0f) ;
                        nSwab.show();
                    // Move Swab Back
                        nSwab.translate(25.0f, 0.0f, 40.0f, 2, 0);
                    // Move MouseBall Back
                        nMouseBall.translate(-80f, 0.0f, -60f, 2, 0);
                   // Render Changes
                        l3d.render() ;
                        backPush = false;
                    }


                    buttonHold = true;
                    backButton.disable();
                    forwardButton.disable();

                    mid1Text.setText("Finally, clean the last roller.");
                    mid2Text.setText("");

                // Move Swab Over
                    float fXPos = 25.0f;
                    float fYPos = 0.0f;
                    float fZPos = 40.0f;
                    for(int i=0; i<10; i++) {
                        fXPos = fXPos - 4.5f;
                        fYPos = fYPos - 2.0f;
                        nSwab.translate(fXPos, fYPos, fZPos, 2, 0);
                        l3d.render() ;
                    }

                // Move Swab Back and Forth
                    for(int i=0; i<3; i++) {
                        nSwab.translate(fXPos, fYPos, fZPos + 5.0f, 2, 0);
                        l3d.render() ;
                        nSwab.translate(fXPos, fYPos, fZPos, 2, 0);
                        l3d.render() ;
                        nSwab.translate(fXPos, fYPos, fZPos - 5.0f, 2, 0);
                        l3d.render() ;
                        nSwab.translate(fXPos, fYPos, fZPos, 2, 0);
                        l3d.render() ;
                    }

                    buttonHold = false;
                    backButton.enable();
                    forwardButton.enable();
                    showScene++;
                    break;

                }

            // Reassemble Mouse Ball
                case 10: {

                    if(backPush) {
                    // Move MouseBall Back
                        nMouseBall.translate(-80f, 0.0f, -60f, 2, 0);
                    // Move HoleCover Back
                        nMouseBall.translate(90f, 0.0f, -40f, 2, 0);
                    // Reset HoleCover Texture
                        nHoleCover.setTransparency(1.0f) ;
                        nHoleCover2.setTransparency(0.0f) ;
                    // Render Changes
                        l3d.render() ;
                        backPush = false;
                    }


                    buttonHold = true;
                    backButton.disable();
                    forwardButton.disable();

                    nSwab.hide();
                    l3d.render() ;

                    mid1Text.setText("Wipe off and then return");
                    mid2Text.setText("the Mouse ball to its position.");

                // Move MouseBall Over
                    float fXPos = -80.0f;
                    float fZPos = -60.0f;
                    for(int i=0; i<10; i++) {
                        fXPos = fXPos + 8.0f;
                        nMouseBall.translate(fXPos, 0.0f, fZPos, 2, 0);
                        l3d.render() ;
                    }

                // Move MouseBall In
                    for(int i=0; i<10; i++) {
                        fZPos = fZPos + 6.0f;
                        nMouseBall.translate(0.0f, 0.0f, fZPos, 2, 0);
                        l3d.render() ;
                    }

                    buttonHold = false;
                    backButton.enable();
                    forwardButton.enable();
                    showScene++;
                    break;
                }

            // ReAssemble Hole Cover
                case 11: {

                    if(backPush) {
                    // Reset Text
                         topText.setText("Cleaning the Mouse");
                    // Move HoleCover Back
                         nHoleCover.translate(90f, 0.0f, -40f, 2, 0);
                    // Reset HoleCover Texture
                        nHoleCover.setTransparency(1.0f) ;
                        nHoleCover.setTransparency(0.0f) ;
                    // Reset Camera
                        l3d.setCameraView(-20f, 120f, -250f,
                                          0f, 0f, 1f,
                                          0f, 1f, 0f);
                    // Render Changes
                        l3d.render() ;
                        backPush = false;
                    }


                    buttonHold = true;
                    backButton.disable();
                    forwardButton.disable();

                    mid1Text.setText("Return the cover to its position");
                    mid2Text.setText("and turn to lock.");

                // Move Hole Cover2 Over
                    float fXPos = 90.0f;
                    float fZPos = -40.0f;
                    for(int i=0; i<10; i++) {
                        fXPos = fXPos - 9.0f;
                        nHoleCover2.translate(fXPos, 0.0f, fZPos, 2, 0);
                        l3d.render() ;
                    }

                // Move Hole Cover2 In
                    for(int i=0; i<10; i++) {
                        fZPos = fZPos + 4.0f;
                        nHoleCover2.translate(0.0f, 0.0f, fZPos, 2, 0);
                        l3d.render() ;
                    }

                // Dissolve from HoleCover to HoleCover2 (fake rotation hack)
                    for(float ff=0.0f;ff<=1.0f;ff+=.1f) {
                        nHoleCover.setTransparency(1.0f-ff) ;
                        nHoleCover2.setTransparency(ff) ;
                        l3d.render() ;
                    }
                    nHoleCover.setTransparency(0.0f) ;
                    nHoleCover2.setTransparency(1.0f) ;
                    l3d.render() ;

                    buttonHold = false;
                    backButton.enable();
                    forwardButton.enable();
                    showScene++;
                    break;
                }

                case 12: {
                    buttonHold = true;
                    backButton.disable();
                    forwardButton.disable();

                    topText.setText("Thank You!!!");
                    mid1Text.setText("Hope you enjoyed this demo.");
                    mid2Text.setText("");

                    float fXPos = -20.0f;
                    float fYPos = 120.0f;
                    float fZPos = -250.0f;
                    float fXLookAt = 0.0f;
                    float fYLookAt = 0.0f;
                    float fZLookAt = 1.0f;
                    float fXLookUp = 0.0f;
                    float fYLookUp = 1.0f;
                    float fZLookUp = 0.0f;

                    for(int i=1; i<6; i++) {
                        fXPos = fXPos + 4f;
                        fZPos = fZPos - 20f;
                        l3d.setCameraView(fXPos, fYPos, fZPos,
                                          fXLookAt, fYLookAt, fZLookAt,
                                          fXLookUp, fYLookUp, fZLookUp);
                        l3d.render();
                    }
                    for(int i=1; i<11; i++) {
                        fXPos = fXPos - 35f;
                        fZPos = fZPos + 35f;
                        fXLookAt = fXLookAt + .1f;
                        fZLookAt = fZLookAt - .1f;
                        l3d.setCameraView(fXPos, fYPos, fZPos,
                                          fXLookAt, fYLookAt, fZLookAt,
                                          fXLookUp, fYLookUp, fZLookUp);
                        l3d.render();
                    }
                    for(int i=1; i<11; i++) {
                        fXPos = fXPos + 35f;
                        fZPos = fZPos + 35f;
                        fXLookAt = fXLookAt - .1f;
                        fZLookAt = fZLookAt - .1f;
                        l3d.setCameraView(fXPos, fYPos, fZPos,
                                          fXLookAt, fYLookAt, fZLookAt,
                                          fXLookUp, fYLookUp, fZLookUp);
                        l3d.render();
                    }

                    nButtonText.translate(0.0f, 0.0f, 0.0f, 2, 0);


                    mid2Text.setText("Push forward to reset");

                    showScene = 0;
                    buttonHold = false;
                    backButton.enable();
                    forwardButton.enable();
                    break;
                }

            }

        }
            return true;
    }

	public JSObject getDocument() {
		return (JSObject)JSObject.getWindow(this).getMember("document");
	}

}
